!ABCIncludeFile
!Copyright Jim Kane, Productive Software Solutions Inc (1999)

OMIT('_EndOfInclude_',_EnumPrtClPresent_)
_EnumPrtClPresent_ EQUATE(1)

!Other Classes
!  Include('OtherClass.INC')

!Equates - will be seen by using program
PrinterQueueType  Queue,Type
ShowName cstring(256)
PrinterName CString(256)
.

JobQType  Queue,type
DocName   string(80)
Thestatus string(80)
Owner     string(80)
Progress  string(80)
StartedAt string(80)
  end
JOB_INFO_2Type Group,Type
JobID               ulong
pPrinterName        Long        !cstring
pMachineName        Long        !cstring
pUserName           Long        !cstring
pDocument           Long        !cstring
pNotifyName         Long        !cstring
pDatatype           Long        !cstring
pPrintProcessor     Long        !cstring
pParameters         Long        !cstring
pDriverName         Long        !cstring
pDevMode            Long        !devmode structure
pStatus             Long        !cstring
pSecurityDescriptor long        !security junk
Status              ulong
Priority            ulong
Position            ulong
StartTime           ulong
UntilTime           ulong
TotalPages          ulong
SIZE                ulong
!SYSTEMTIME Submitted;
wYear               ushort
wMonth              ushort
wDayOfWeek          ushort
wDay                ushort
wHour               ushort
wMinute             ushort
wSecond             ushort
wMilliseconds       ushort
Time                ulong
PagesPrinted        ulong
  end



EnumPrtClType Class,type,module('EnumPtr.CLW'),LINK('EnumPtr.CLW',_abcLinkMode_),DLL(_abcDllMode_)
PrinterQueue        &PrinterQueueType
LastPrinterUsed     Cstring(128)
IsNT	            byte
DefaultPrinterNT    cstring(256)

Init                Procedure()
Kill                Procedure()
OpenPrinter         procedure(*cstring defaultPrinter, long lphprinter),bool
GetPrinterList      Procedure(*PrinterQueueType PrinterQueue),Long,Proc                                         !fills a Q with printer names
GetDefaultPrinter   Procedure(*Cstring DefaultPrinter),Long,proc                                                !returns the default printer name
PopPrtDlg           Procedure(*Cstring PrinterName),byte                                                        !displays a dialog, user picks a printer
DirectPrtFile       Procedure(byte PopPrtDlg=1,<*Cstring PrinterName>,*Cstring fname,byte prtff=1),byte,Proc    !Send a file directly to a printer
DirectPrtBlock      Procedure(byte PopPrtDlg=1,<*Cstring PrinterName>,Long lpdata,Long datalen,byte prtff=1),byte,proc  !send a block of data from memory to a printer
EnumJobs            Procedure(byte PopPrtDlg=1,<*Cstring printerName>, jobQType jobQ),byte,proc                 !Get a Queue of print jobs for the choosen printer
SetDefaultPrinter   Procedure(byte PopPrtDlg=1,<*Cstring xPrinterName>),byte,proc                               !set the windows default printer

!Nt stuff
SetDefaultPrinterNT Procedure(*cstring printerName),byte
IsDefaultPrinterNT  Procedure(*cstring PrinterName),byte
isDefaultPrinter    Procedure(long Printerattributes,*cstring PrinterName),byte
GetDefaultPrinterNT Procedure(),byte,proc

!Utility functions
GetPrinterInfo      Procedure(unsigned hprinter, *unsigned hglobal, *long lpGlobal, *ulong cbNeeded),byte        !Gets a printer_Info_2 structure for a printer
SetPrinterInfo      Procedure(unsigned hprinter, long lpglobal, long command),byte                              !Sets a printer_Info_2 structure for a printer
CopyString          Procedure(*string CWStr, long lpCStr),private                                               !Copy a cstring from a memory address to a CW string
GethPrinter         procedure(byte PopPtrDlg, *cstring PrinterName),unsigned,private                            !hprinter is returned or 0 on error - 'Opens a printer'

    end
 !_EndOfInclude_